#!/usr/bin/env python

try:  
	import pygtk  
	pygtk.require("2.0")  
except:  
	pass  
try:  
	import gtk  
	import gtk.glade  
	from subprocess import call
except:  
	print("GTK Not Availible")
	sys.exit(1)

import sys
import os
import shlex, subprocess
import ConfigParser
import gobject
import re

#BRIDGE_BASENAME = "b"
#MAC0_BASE_HALF_ADDRESS = "000001"
#IP0_BASE_ADDRESS = "10.125.11.0"
#NETMASK0 = "255.255.255.0"
#BASENAME = "vm"
TOOLS_DIR = "vbox/tools"


def set_combobox_model_from_list (cb, items):
            """Setup a ComboBox or ComboBoxEntry based on a list of integers
	       info: http://faq.pygtk.org/index.py?req=show&file=faq16.008.htp ,
	             http://faq.pygtk.org/index.py?query=prepend&querytype=simple&req=search"""    

	    model = cb.get_model()
	    if model:
	       cb.set_model(None)
	       model.clear()
               cb.clear()
	    else:
	       model = gtk.ListStore(type(items[0]))
	       #model = gtk.TreeStore(type(items[0]))
	       #model = gtk.TreeModel()
            for i in items:
               model.append([i])
            cb.set_model(model)
    	    if type(cb) == gtk.ComboBoxEntry:
	       cb.set_text_column(0)
            elif type(cb) == gtk.ComboBox:
               cell = gtk.CellRendererText()
               cb.pack_start(cell, True)
               cb.add_attribute(cell, 'text', 0)

def get_active_combobox_value (widget):
	model = widget.get_model()
	it = widget.get_active_iter()
	return model.get_value(it, 0)
	#model = combobox.get_model()
	#active = combobox.get_active()
	#if active < 0:
   	#   return None
	#return model[active][0]




class ConfVBoxApi(object):       
	def __init__(self, *args, **kwargs):
            if len(args) == 1:  self.ext = True;
            else:               self.ext = False;
	    self.builder = gtk.Builder()
	    self.builder.add_from_file("vbox_config.glade")
	    if self.ext==False:
	    	self.builder.connect_signals({ "gtk_main_quit" : gtk.main_quit,
					       "gen_do_button_clicked_cb" : self.gen_do_button_do,
					       "del_do_button_clicked_cb" : self.del_do_button_do,
					       #"gen_sel_combobox_button_press_event_cb" : self.gen_sel_update_list
 						})#,
	    else:
	        self.builder.connect_signals({ "gtk_main_quit" : self.quit,
					       "gen_do_button_clicked_cb" : self.gen_do_button_do,
					       "del_do_button_clicked_cb" : self.del_do_button_do,
					       #"gen_sel_combobox_button_press_event_cb" : self.gen_sel_update_list
 					})#,
                self.parent = args[0]
		self.parent.window.set_sensitive(False)
   
            self.window = self.builder.get_object("config_vbox_window")
	    #Generate notepad
	    self.gen_sel_combo = self.builder.get_object("gen_sel_combobox")
	    set_combobox_model_from_list (self.gen_sel_combo, re.findall('"([a-zA-Z0-9\_?]+)+"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0]))
            #self.gen_sel_combo.set_active(0)

	    self.gen_from_entry = self.builder.get_object("gen_from_entry")
	    self.gen_to_entry = self.builder.get_object("gen_to_entry")
	    self.gen_do_button = self.builder.get_object("gen_do_button")

	    #Delete notepad
	    self.del_from_entry = self.builder.get_object("del_from_entry")
	    self.del_to_entry = self.builder.get_object("del_to_entry")
	    self.del_do_button = self.builder.get_object("del_do_button")

	    #Info notepad
	    self.conf_info_textview = self.builder.get_object("conf_info_textview")
	    buf = gtk.TextBuffer()
	    buf.set_text("""To use this tool at lest one VirtualBox\nmachine should be already created as\nit was described in vbox/README file.""")
	    self.conf_info_textview.set_buffer(buf)

            self.config = ConfigParser.RawConfigParser()

	    self.window.show()

	def quit(self, widget):
	    self.parent.window.set_sensitive(True)
	    self.parent.on_confvboxapi_quit(self)

	def gen_do_button_do(self, widget):
	    if (self.gen_from_entry.get_text()) and (self.gen_to_entry.get_text()) and (self.gen_sel_combo.get_active()):

	       self.config.read(TOOLS_DIR+"/vbox_config.conf")
	       bridge_basename = self.config.get("vbox_config", "vbox_bridge_basename").strip().split()
	       mac0_base_half_addr = self.config.get("vbox_config", "mac0_base_half_address").strip().split()
	       ip0_base_addr = self.config.get("vbox_config", "ip0_base_addr").strip().split()
	       nmask0 = self.config.get("vbox_config", "netmask0").strip().split()
	       vbox_basename = self.config.get("vbox_config", "vbox_basename").strip().split()

	       source_vm_name = get_active_combobox_value(self.gen_sel_combo)
	       from_vm_number = self.gen_from_entry.get_text()
	       to_vm_number = self.gen_to_entry.get_text()

               command_line = 'gnome-terminal -t "VBox manager" -e "/bin/sh -c \'./mkvnodes ' + source_vm_name +' '+ from_vm_number +' '+ to_vm_number +' '+ bridge_basename[0] +' '+ mac0_base_half_addr[0] +' '+ ip0_base_addr[0] +' '+ nmask0[0] +' '+ vbox_basename[0] +'; echo Press any key to exit; read x\'" --hide-menubar'

	       #print command_line
	       args = shlex.split(command_line)
	       p = subprocess.Popen(args,cwd=(os.getcwd()+'/'+TOOLS_DIR))
	       set_combobox_model_from_list (self.gen_sel_combo, re.findall('"([a-zA-Z0-9\_?]+)+"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0]))
	    else:
                self.show_info_message("""The virtual machine name or/and range not filled!""")

	def del_do_button_do(self, widget):
	    if (self.del_from_entry.get_text()) and (self.del_to_entry.get_text()):

	       self.config.read(TOOLS_DIR+"/vbox_config.conf")
	       vbox_basename = self.config.get("vbox_config", "vbox_basename").strip().split()

	       from_vm_number = self.del_from_entry.get_text()
	       to_vm_number = self.del_to_entry.get_text() 
	       command_line = 'gnome-terminal -t "VBox manager" -e "/bin/sh -c \'./rmvnodes '+ vbox_basename[0] +' '+ from_vm_number +' '+ to_vm_number +'; echo Press any key to exit; read x\'" --hide-menubar'
	       #print command_line
	       args = shlex.split(command_line)
	       p = subprocess.Popen(args,cwd=(os.getcwd()+'/'+TOOLS_DIR))
               set_combobox_model_from_list (self.gen_sel_combo, re.findall('"([a-zA-Z0-9\_?]+)+"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0]))
	    else:
                self.show_info_message("""The virtual machine range not filled, or none to delete!""")

	def show_info_message(self, mess):	    
 	    message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_NONE, mess)
 	    message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
 	    resp = message.run()
 	    if resp == gtk.RESPONSE_CLOSE:
		message.destroy()

	#def gen_sel_update_list(self, widget):
	 #   set_combobox_model_from_list (self.gen_sel_combo, re.findall('"([a-zA-Z0-9\_?]+)+"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0]))
		

if __name__ == "__main__":
	app = ConfVBoxApi()
	gtk.main()



